/* 
 * DHCP Web Services MMC 3.0 Snap-In Client
 *
 *  File: RezScopeNode.cs
 *  Namespace: Unf.Dhcp.ManagementConsole
 *  
 *
 * Copyright (c) 2008 Jason Rupard 
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 * 
 *     * Redistributions of source code must retain the above copyright notice,
 *     this list of conditions and the following disclaimer.
 * 
 *     * Redistributions in binary form must reproduce the above copyright
 *     notice, this list of conditions and the following disclaimer in the
 *     documentation and/or other materials provided with the distribution.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 * 
*/
using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.ManagementConsole;

using Unf.Dhcp.ManagementConsole.DwsOps;

namespace Unf.Dhcp.ManagementConsole
{
    class RezResultNode : ResultNode
    {
        public DhcpReservation Reservation;
        public OptionScopeNode OptionNode;
        public RezResultNode(DhcpReservation rez)
        {
            this.Reservation = rez;
            this.DisplayName = rez.ReservedIp.ToString();
            this.ImageIndex = 6;
            this.SubItemDisplayNames.Add(rez.Name ?? String.Empty); //name
            this.SubItemDisplayNames.Add(rez.ReservedMac.Mac ?? String.Empty);
            this.SubItemDisplayNames.Add(Enum.GetName(typeof(DhcpSubnetClientType), rez.bAllowedClientTypes));
            this.SubItemDisplayNames.Add(rez.Comment ?? String.Empty);

            
        }

        public void SetOptionNode(SubnetScopeNode subnetNode)
        {
            DhcpOptionScope os = new DhcpOptionScope(subnetNode.DhcpSubnet.Address, Reservation.ReservedIp);
            this.OptionNode = new OptionScopeNode(subnetNode.ServerNode, os);
            
        }

    }
}
