/* 
 * DHCP Web Services MMC 3.0 Snap-In Client
 *
 *  File: SubnetListView.cs
 *  Namespace: Unf.Dhcp.ManagementConsole
 *  
 *
 * Copyright (c) 2008 Jason Rupard 
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met:
 * 
 *     * Redistributions of source code must retain the above copyright notice,
 *     this list of conditions and the following disclaimer.
 * 
 *     * Redistributions in binary form must reproduce the above copyright
 *     notice, this list of conditions and the following disclaimer in the
 *     documentation and/or other materials provided with the distribution.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 * 
*/
using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.ManagementConsole;

namespace Unf.Dhcp.ManagementConsole
{
    public class SubnetListView : MmcListView
    {
        public SubnetListView()
        {
        }

        protected override void OnInitialize(AsyncStatus status)
        {
            // do default handling
            base.OnInitialize(status);

            
            // Create a set of columns for use in the list view
            // Define the default column title
            this.Columns[0].Title = "IP";
            this.Columns[0].SetWidth(150);
            

            // Add detail column
            this.Columns.Add(new MmcListViewColumn("Mask", 100));
            this.Columns.Add(new MmcListViewColumn("Name", 100));
            this.Columns.Add(new MmcListViewColumn("State", 65));
            this.Columns.Add(new MmcListViewColumn("Description", 100, MmcListViewColumnFormat.Left, false));


            this.ActionsPaneItems.Add(new Action("Search...", "SearchView", 3, "SearchView"));

        }

        /// <summary>
        /// Handle when the action is clicked in context menu or action pane
        /// </summary>
        /// <param name="action"></param>
        /// <param name="status"></param>
        protected override void OnAction(Action action, AsyncStatus status)
        {
            if ((string)action.Tag == "SearchView")
            {
                // trigger MMC to show the new view
                ((ServerScopeNode)this.ScopeNode).SwapView(this, "Search...", typeof(SearchListView));
            }
        }
    }
}
